<!DOCTYPE html>
<html lang="nl">
<head>
	<meta charset="utf-8">
	<title>Nummerreeks App | Print Setup</title>
	<link rel="stylesheet" href="/static/css/bootstrap/bootstrap.min.css">
	<link rel="stylesheet" href="/static/css/bcd.css">
	<script src="/static/js/jquery-3.5.1.js"></script>
	<script src="/static/js/bootstrap/bootstrap.min.js"></script>
	<script src="/static/js/bcd.util.js"></script>
	<script src="/static/js/bcd.shared.js"></script>
	<script src="/static/js/bcd.dialog.js"></script>
	<style>
		.code {
			font-family: 'Noto Mono','Courier New','Mono';
		}
	</style>
	<script>
		const BASE_PATH = "~%basePath%";
		const UPDATED = ~%updated%;
		const ORIG_LAYOUT_ID = ~%layoutId%;
		const ORIG_JSON = '~%js:json%';
		const PERMISSION = '~%permission%';

		function getLayout() {
			const id = parseInt($("#layoutId").val());
			if(id === 0) {
				$("#layoutTemplate").text("");
				$("#jsonConfig").val("").prop("disabled", true).css("backgroundColor", "#fff");
			} else if(id === ORIG_LAYOUT_ID) {
				$("#jsonConfig").val(ORIG_JSON).prop("disabled", false).css("backgroundColor", "#000");
			} else {
				action(id);
			}
		}

		function copyConfig() {
			const layoutId = $("#layoutId").val();
			if(layoutId === "0") {
				showWarning("Selecteer eerst een formaat");
				return;
			}
			const oldName = $("#layoutId option:selected").text();
			const newName = oldName + " (Kopie)";
			const message = $("<div><b>Geef een nieuwe naam aan dit formaat</b><br>"
					+ "<input name='layoutName' value='" + newName + "' style='width:350px;margin-top:10px;'></div>");
			bsConfirm(message, function() {
				bsHideDialog();
				const n = encodeURIComponent(message.find("input").val());
				action(layoutId + "/copy/?newName=" + n);
			});
		}

		function deleteConfig() {
			const layoutId = $("#layoutId").val();
			if(layoutId === "0") {
				showWarning("Geen formaat geselecteerd");
				return;
			}
			const name = $("#layoutId option:selected").text();
			const message = "Weet je zeker dat je formaat \"" + name + "\" wilt weggooien? "
				+ "Alle instellingen voor dit formaat zullen definitief verloren gaan!";
			bsConfirmWarning(message, function() {
				bsHideDialog();
				action(layoutId + "/delete");
			});
		}

		function showLegend() {
			const id = $("#layoutId").val();
			if(id === "0") {
				showWarning("Selecteer eerst een formaat");
			} else {
				action(id + "/legend");
			}
		}

		function updateConfig() {
			const id = $("#layoutId").val();
			if(id === "0") {
				showWarning("Geen formaat geselecteerd");
				return;
			}
			const jsonConfig = $("#jsonConfig").val();
			if(jsonConfig === ORIG_JSON) {
				showWarning("De configuratie is nog niet gewijzigd");
				return;
			}
			try {
				JSON.parse(jsonConfig);
			} catch(e) {
				showError(
					"<p style=\"color:#f00\"><b>Invalide configuratie</b></p>"
					+ "<p><ul style=\"font-size:92%\">"
					+ "<li>Configuratie moet beginnen met <b>{</b> en eindigen met <b>}</b></li>"
					+ "<li>Namen van instellingen moeten tussen dubbele aanhalingstekens</li>"
					+ "<li>Waardes van instellingen moeten tussen dubbele aanhalingstekens. Voor "
					+ "getallen en voor de waardes <span class=\"code\">true</span> en "
					+ "<span class=\"code\">false</span> is dit optioneel.</li>"
					+ "<li>Namen en waardes scheiden d.m.v. dubbele punt</li>"
					+ "<li>Elke regel met een instelling moet eindigen met een komma <b>behalve "
					+ "de laatste regel</b></li>"
					+ "<li>Inspringen, uitlijnen en aanpassen volgorde v.d. instellingen toegestaan</li>"
					+ "</ul></p>"
				);
				return;
			}
			action(id+"/updateConfig/?jsonConfig=" + encodeURIComponent(jsonConfig));
		}
	</script>

</head>

<body>

~%%include:adminNavbar:/html/include/AdminNavbar.html%

<h1>Print Setup</h1>

<div class="center-screen" >
	<div class="small-input-container">
		<table id="input-container">
			<tr>
				<td class="left-col"><label for="layoutId">Formaat</label></td>
				<td class="right-col">
					<select id="layoutId" name="layoutId"  onchange="getLayout()">
					~%layoutOptions%
					</select>
				</td>
			</tr>
			<tr>
				<td class="left-col">Sjabloon</td>
				<td class="right-col">~%template%</td>
			</tr>
			<tr>
				<td class="left-col">Toepassing</td>
				<td class="right-col">~%labelUsage%</td>
			</tr>
			<tr>
				<td class="left-col"><label for="jsonConfig">Configuratie</label></td>
				<td class="right-col">
					<textarea
						id="jsonConfig"
						name="jsonConfig"
						class="code"
						rows="~%rows%"
						cols="~%cols%"
						disabled="disabled"
						style="text-align:left;color:#0f0;font-size:88%">~%json%</textarea>
				</td>
			</tr>
		</table>
			
		<div style="padding:20px 0 5px 0;width:100%;text-align:center;">
			<button class="btn btn-outline-primary" onclick="updateConfig()">
				Opslaan
			</button>
			<button class="btn btn-outline-primary" onclick="copyConfig()">
				Kopiëren
			</button>
			<button class="btn btn-outline-primary" onclick="deleteConfig()">
				Verwijderen
			</button>
			<button class="btn btn-outline-primary" onclick="showLegend()">
				Uitleg
			</button>
		</div>		
	</div>
</div>

~%%include:bsDialog:/html/include/BSDialog.html%
	
<script>	
$(function() {

	const h1 = $("h1");
	recenter(h1);
	$(window).resize(function() {
		recenter(h1);
	});
	
	$("#simpleSearchTextInput").css("display", "none");	
	$("#simpleSearchButton").css("display", "none");
	
	const x = $("#jsonConfig").outerWidth();
	const y = $("#layoutId").outerWidth();
	
	if(x > y) {
		$("#layoutId").outerWidth(x);
	} else {
		$("#jsonConfig").outerWidth(y);
	}
	
	if(ORIG_LAYOUT_ID === 0) {
		$("#jsonConfig").val("").prop("disabled", true).css("backgroundColor", "#fff");
	} else {
		$("#layoutId").val(ORIG_LAYOUT_ID);
		$("#jsonConfig").prop("disabled", false).css("backgroundColor", "#000");
	}
	
	if(UPDATED) {
		showSuccess("Configuratie bijgewerkt");
	}

});
</script>

</body>
</html>